#include <stm32f4xx_gpio.h>
#include <stm32f4xx_rcc.h>
#include <stm32f4xx_usart.h>
#include <stdio.h>

GPIO_InitTypeDef  GPIO_InitStructure;

uint8_t RxData[256]; //  
uint8_t TxData[256]; //   
volatile uint8_t RxIn = 0;
volatile uint8_t RxOut = 0;
volatile uint8_t TxIn = 0;
volatile uint8_t TxOut = 0;
//uint8_t RxEmpty=1;
uint32_t cnt=0;

void UsartTx(){
	if(TxIn != TxOut){
		uint8_t tmp=TxData[TxOut++];
		USART_SendData(USART3, tmp);
	}
}
void UsartSend(){
	//if((USART3->SR & USART_SR_TXE) && (TxIn != TxOut)){
	if((USART_GetFlagStatus(USART3,USART_FLAG_TXE)!= RESET) && (TxIn != TxOut)){
		UsartTx();
	}
}
void UsartRx(){
	int tmp=RxIn-RxOut;
	if(tmp<256 && tmp!=-1){
		RxData[RxIn++]=USART_ReceiveData(USART3);
	}
}
uint8_t UsartTestData(){
	return RxIn!=RxOut;
}
uint8_t UsartGetData(){
	return RxData[RxOut++];
}
char UsartPutData(char Dt){
	int tmp=TxIn-TxOut;
	if(tmp<255 && tmp!=-1){
		TxData[TxIn++]=Dt;
		return 1;
	}
	return 0;
}



void Delay(__IO uint32_t nCount);

void initAll()
{
    //  
    __enable_irq();

    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;

    /* Enable GPIO clock */
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);

    /* Enable UART clock */
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);

    /* Connect PXx to USARTx_Tx*/
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource10, GPIO_AF_USART3);

    /* Connect PXx to USARTx_Rx*/
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource11, GPIO_AF_USART3);

    /* Configure USART Tx as alternate function  */
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    /* Configure USART Rx as alternate function  */
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    //GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = 9600;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

    /* USART configuration */
    USART_Init(USART3, &USART_InitStructure);

    /* Enable USART */
    NVIC_EnableIRQ(USART3_IRQn);
    USART_Cmd(USART3, ENABLE);

   //     USART


    USART_ITConfig(USART3, USART_IT_TC, ENABLE);
    USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);

}

int main(void)
{

	SystemInit();
	initAll();

	/* GPIOD Periph clock enable */
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);

	/* Configure PD12, PD13, PD14 and PD15 in output pushpull mode */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12 | GPIO_Pin_13| GPIO_Pin_14| GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOD, &GPIO_InitStructure);
	//Delay(0x3FFFFF);

	UsartPutData('9');
	UsartPutData('8');
	UsartPutData('7');
	UsartPutData('6');
	UsartPutData('5');
	UsartPutData('4');
	UsartPutData('3');
	UsartPutData('2');
	UsartPutData('1');
	UsartPutData('0');

	while(1)
	    {
			if(UsartTestData()){
				uint8_t tmp=UsartGetData();
				//UsartPutData(tmp+1);
				printf("Test:\"%c\"\n",tmp);
				//UsartSend();
			}
			
	    }

 
}



//  
void USART3_IRQHandler()
{
	if (USART_GetITStatus(USART3, USART_IT_TC) != RESET)
	{

	    //   
		USART_ClearITPendingBit(USART3, USART_IT_TC);
	   	UsartTx();
	}

	if(USART_GetITStatus(USART3, USART_IT_RXNE)!=RESET)
	{
    	UsartRx();
    }

}

void Delay(__IO uint32_t nCount)
{
  while(nCount--)
  {
  }
}

